Index: /bdm/estim/libPF.h
===================================================================
--- /bdm/estim/libPF.h (revision 15)
+++ /bdm/estim/libPF.h (revision 28)
@@ -38,5 +38,6 @@
 	PF (vec w);
 	//TODO remove or implement bayes()!
-	void bayes(const vec &dt, bool evell){};
+	void bayes(const vec &dt){};
+	epdf* _epdf(){return NULL;}
 };
 
@@ -51,10 +52,10 @@
 	
 	bool is_proposal;
-	mpdf *prop;
+	BM *prop;
 	mpdf *par;
 	mpdf *obs;
 	
 	public:
-	TrivialPF(mpdf &par, mpdf &obs, mpdf &prop, int n0);
+	TrivialPF(mpdf &par, mpdf &obs, BM &prop, int n0);
 	TrivialPF(mpdf &par, mpdf &obs, int n0);
 	void bayes(const vec &dt, bool evalll);
@@ -64,5 +65,5 @@
 	Array<BM> Bms;
 	public:
-	MPF(BM &B, mpdf &prop, mpdf &obs, mpdf &par);
+	MPF(BM &B, BM &prop, mpdf &obs, mpdf &par);
 	void bayes(vec &dt);	
 };
Index: /bdm/estim/libKF.cpp
===================================================================
--- /bdm/estim/libKF.cpp (revision 27)
+++ /bdm/estim/libKF.cpp (revision 28)
@@ -28,5 +28,5 @@
 }
 
-void KalmanFull::bayes( const vec &dt, bool evalll ) {
+void KalmanFull::bayes( const vec &dt) {
 	it_assert_debug( dt.length()==( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
 
Index: /bdm/estim/libKF.h
===================================================================
--- /bdm/estim/libKF.h (revision 22)
+++ /bdm/estim/libKF.h (revision 28)
@@ -16,5 +16,5 @@
 #include <itpp/itbase.h>
 #include "../stat/libFN.h"
-#include "../math/libDC.h"
+#include "../stat/libEF.h"
 
 
@@ -41,5 +41,6 @@
 	KalmanFull ( mat A, mat B, mat C, mat D, mat R, mat Q, mat P0, vec mu0);
 	//! Here dt = [yt;ut] of appropriate dimensions
-	void bayes(const vec &dt, bool evalll=true); 
+	void bayes(const vec &dt); 
+	epdf* _epdf(){return NULL;}; 
 
 	friend std::ostream &operator<< ( std::ostream &os, const KalmanFull &kf );
@@ -58,25 +59,31 @@
 	sq_T R, Q;
 	
-	//cache
+	//!posterior on $x_t$
+	enorm<sq_T> est;
+	//!preditive density on $y_t$
+	enorm<sq_T> fy;
+	
 	mat _K;
-	vec _yp;
-	sq_T _Ry,_iRy;
-public:
-	//posterior 
-	//! Mean value of the posterior density
-	vec mu;
-	//! Mean value of the posterior density
-	sq_T P;
-
+	//cache of fy
+	vec* _yp; 
+	sq_T* _Ry,*_iRy;
+	//cache of est
+	vec* _mu;
+	sq_T* _P, *_iP;
+	
 public:
 	//! Default constructor
-	Kalman (int dimx, int dimu, int dimy);
-	//! Full constructor 
-	Kalman ( mat A0, mat B0, mat C0, mat D0, sq_T R0, sq_T Q0, sq_T P0, vec mu0 );
+	Kalman (RV rvx0, RV rvy0, RV rvu0);
+	//! Set parameters with check of relevance 
+	void set_parameters (const mat &A0,const mat &B0,const mat &C0,const mat &D0,const sq_T &R0,const sq_T &Q0);
+	//! Set estimate values, used e.g. in initialization.
+	void set_est(const vec &mu0, const sq_T &P0 ){est.set_parameters(mu0,P0);};
 	//! Here dt = [yt;ut] of appropriate dimensions
-	void bayes(const vec &dt, bool evalll=true); 
-
-	friend std::ostream &operator<< ( std::ostream &os, const KalmanFull &kf );
-
+	void bayes(const vec &dt); 
+
+//	friend std::ostream &operator<< ( std::ostream &os, const Kalman<sq_T> &kf );
+
+	//!access functions
+	enorm<sq_T>* _epdf(){return &est;} 
 };
 
@@ -87,5 +94,5 @@
 */
 template<class sq_T>
-class EKF : public Kalman<fsqmat> {
+class EKF : public Kalman<ldmat> {
 	//! Internal Model f(x,u)
 	diffbifn* pfxu;
@@ -94,7 +101,8 @@
 public:	
 	//! Default constructor
-	EKF (diffbifn* pfxu, diffbifn* phxu, sq_T Q0, sq_T R0, vec mu0, mat P0);
+	EKF (RV rvx, RV rvy, RV rvu);
+	void set_parameters(diffbifn* pfxu, diffbifn* phxu, const sq_T Q0, const sq_T R0);
 	//! Here dt = [yt;ut] of appropriate dimensions
-	void bayes(const vec &dt, bool evalll=true); 	
+	void bayes(const vec &dt); 	
 };
 
@@ -102,20 +110,19 @@
 
 template<class sq_T>
-Kalman<sq_T>::Kalman( int dx, int du, int dy): BM(), dimx(dx),dimy(dy),dimu(du){
-	A = mat(dimx,dimx);
-	B = mat(dimx,dimu);
-	C = mat(dimy,dimx);
-	D = mat(dimy,dimu);
-
-	mu = vec(dimx);
-	//TODO Initialize the rest?
-};
-
-template<class sq_T>
-Kalman<sq_T>::Kalman(const  mat A0,const  mat B0, const mat C0, const mat D0, const sq_T R0, const sq_T Q0, const sq_T P0, const vec mu0 ): BM() {
-	dimx = A0.rows();
-	dimu = B0.cols();
-	dimy = C0.rows();
-
+Kalman<sq_T>::Kalman(RV rvx, RV rvy, RV rvu): BM(),
+dimx(rvx.count()), dimy(rvy.count()),dimu(rvu.count()), 
+ A(dimx,dimx), B(dimx,dimu), C(dimy,dimx), D(dimy,dimu), est(rvx), fy(rvy){
+//assign cache
+//est
+_mu = est._mu();
+est._R(_P,_iP);
+
+//fy
+_yp = fy._mu();
+fy._R(_Ry,_iRy);
+};
+
+template<class sq_T>
+void Kalman<sq_T>::set_parameters(const mat &A0,const  mat &B0, const mat &C0, const mat &D0, const sq_T &R0, const sq_T &Q0) {
 	it_assert_debug( A0.cols()==dimx, "Kalman: A is not square" );
 	it_assert_debug( B0.rows()==dimx, "Kalman: B is not compatible" );
@@ -130,15 +137,9 @@
 	D = D0;
 	R = R0;
-	Q = Q0;
-	mu = mu0;
-	P = P0;
-
-//Fixme should we assign cache??
-	_iRy = eye(dimy); // needed in inv(_iRy)
-	_Ry = eye(dimy); // needed in inv(_iRy)
+	Q = Q0;	
 }
 
 template<class sq_T>
-void Kalman<sq_T>::bayes( const vec &dt , bool evalll) {
+void Kalman<sq_T>::bayes( const vec &dt) {
 	it_assert_debug( dt.length()==( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
 
@@ -146,25 +147,27 @@
 	vec y = dt.get( 0,dimy-1 );
 	//Time update
-	mu = A*mu + B*u;
+	*_mu = A*(*_mu) + B*u;
 	//P  = A*P*A.transpose() + Q; in sq_T
-	P.mult_sym( A );
-	P+=Q;
+	_P->mult_sym( A );
+	(*_P)+=Q;
 
 	//Data update
 	//_Ry = C*P*C.transpose() + R; in sq_T
-	P.mult_sym( C, _Ry);
-	_Ry+=R;
-
-	mat Pfull = P.to_mat();
-	
-	_Ry.inv( _iRy ); // result is in _iRy;
-	_K = Pfull*C.transpose()*(_iRy.to_mat());
-	P -= _K*C*Pfull; // P = P -KCP;
-	_yp = y-C*mu-D*u; //y prediction
-	mu += _K*( _yp );
+	_P->mult_sym( C, *_Ry);
+	(*_Ry)+=R;
+
+	mat Pfull = _P->to_mat();
+	
+	_Ry->inv( *_iRy ); // result is in _iRy;
+	_K = Pfull*C.transpose()*(_iRy->to_mat());
+	
+	sq_T pom((int)Pfull.rows());
+	_iRy->mult_sym_t(C*Pfull,pom);
+	(*_P) -= pom; // P = P -PC'iRy*CP;
+	(*_yp) = C*(*_mu)+D*u; //y prediction
+	(*_mu) += _K*( y-(*_yp) );
 	
 	if (evalll==true) {
-	ll+= -0.5*(_Ry.cols()*0.79817986835811504957 \
-	+_Ry.logdet() +_iRy.qform(_yp));
+		ll+=fy.evalpdflog(*_yp);
 	}
 };
@@ -173,17 +176,19 @@
 
 template<class sq_T>
-EKF<sq_T>::EKF( diffbifn* pfxu0,  diffbifn* phxu0, sq_T Q0, sq_T R0, vec mu0, mat P0): pfxu(pfxu0), phxu(phxu0), Kalman<fsqmat>(pfxu0->_dimx(),pfxu0->_dimu(),phxu0->_dimy()) {
+EKF<sq_T>::EKF(RV rvx0, RV rvy0, RV rvu0): Kalman<ldmat>(rvx0,rvy0,rvu0){}
+
+template<class sq_T>
+void EKF<sq_T>::set_parameters(diffbifn* pfxu0,  diffbifn* phxu0,const sq_T Q0,const sq_T R0) {
+		pfxu = pfxu0;
+		phxu = phxu0;
 		
 		//initialize matrices A C, later, these will be only updated!
-		pfxu->dfdx_cond(mu,zeros(dimu),A,true);
-		pfxu->dfdu_cond(mu,zeros(dimu),B,true);
-		phxu->dfdx_cond(mu,zeros(dimu),C,true);
-		phxu->dfdu_cond(mu,zeros(dimu),D,true);
-		
+		pfxu->dfdx_cond(*_mu,zeros(dimu),A,true);
+		pfxu->dfdu_cond(*_mu,zeros(dimu),B,true);
+		phxu->dfdx_cond(*_mu,zeros(dimu),C,true);
+		phxu->dfdu_cond(*_mu,zeros(dimu),D,true);
 
 		R = R0;
 		Q = Q0;
-		mu = mu0;
-		P = P0;
 
 	using std::cout;
@@ -196,5 +201,5 @@
 
 template<class sq_T>
-void EKF<sq_T>::bayes( const vec &dt , bool evalll) {
+void EKF<sq_T>::bayes( const vec &dt) {
 	it_assert_debug( dt.length()==( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
 
@@ -202,29 +207,26 @@
 	vec y = dt.get( 0,dimy-1 );
 	//Time update
-	mu = pfxu->eval(mu, u);
-	pfxu->dfdx_cond(mu,u,A,false); //update A by a derivative of fx
+	*_mu = pfxu->eval(*_mu, u);
+	pfxu->dfdx_cond(*_mu,u,A,false); //update A by a derivative of fx
 	
 	//P  = A*P*A.transpose() + Q; in sq_T
-	P.mult_sym( A );
-	P+=Q;
+	_P->mult_sym( A );
+	(*_P)+=Q;
 
 	//Data update
-	phxu->dfdx_cond(mu,u,C,false); //update C by a derivative hx
+	phxu->dfdx_cond(*_mu,u,C,false); //update C by a derivative hx
 	//_Ry = C*P*C.transpose() + R; in sq_T
-	P.mult_sym( C, _Ry);
-	_Ry+=R;
-
-	mat Pfull = P.to_mat();
-	
-	_Ry.inv( _iRy ); // result is in _iRy;
-	_K = Pfull*C.transpose()*(_iRy.to_mat());
-	P -= _K*C*Pfull; // P = P -KCP;
-	_yp = y-phxu->eval(mu,u); //y prediction
-	mu += _K*( _yp );
-	
-	if (evalll==true) {
-	ll+= -0.5*(_Ry.cols()*0.79817986835811504957 \
-	+_Ry.logdet() +_iRy.qform(_yp));
-	}
+	_P->mult_sym( C, *_Ry);
+	(*_Ry)+=R;
+
+	mat Pfull = _P->to_mat();
+	
+	_Ry->inv( *_iRy ); // result is in _iRy;
+	_K = Pfull*C.transpose()*(_iRy->to_mat());
+	(*_P) -= _K*C*Pfull; // P = P -KCP;
+	*_yp = phxu->eval(*_mu,u); //y prediction
+	(*_mu) += _K*( y-*_yp );
+	
+	if (evalll==true) {ll+=est.evalpdflog(y);}
 };
 
Index: /bdm/estim/libPF.cpp
===================================================================
--- /bdm/estim/libPF.cpp (revision 14)
+++ /bdm/estim/libPF.cpp (revision 28)
@@ -81,5 +81,5 @@
 }
 
-TrivialPF::TrivialPF( mpdf &par0, mpdf &obs0, mpdf &prop0, int n0 ) : PF(1/n*ones(n)) {
+TrivialPF::TrivialPF( mpdf &par0, mpdf &obs0, BM &prop0, int n0 ) : PF(1/n*ones(n)) {
 	is_proposal = true;
 	prop = &prop0;
@@ -99,13 +99,17 @@
 	Sort<double> S;
 	ivec ind, iw;
-	/*
+	
 	//generate new samples
 	for ( i=0;i<n;i++ ) {
-		prop->evalcond( ptcls( i ), &prop_cond );
-		ptcls( i ) = prop_cond.sample();
-		gl = prop_cond.eval( ptcls( i ) );
+		if(is_proposal) {
+			epdf* prop_epdf;
+	//		prop_epdf = prop._epdf();
+			prop->bayes(dt);
+			ptcls( i ) = prop_epdf->sample();
+			}
+//		gl = prop_cond.eval( ptcls( i ) );
 
-		obs.evalcond( ptcls( i ), &obs_cond );
-		ll = obs_cond.eval( dt );
+//		obs.evalcond( ptcls( i ), &obs_cond );
+//		ll = obs_cond.eval( dt );
 		w( i ) *= ll/gl;
 	}
@@ -113,5 +117,5 @@
 	for ( i=0;i<n;i++ ){sum+=w( i );};
 	w( i ) /=sum; //?
-	//
+	
 	ind = resample();
 	iw = S.sort_index( 0,n-1,w ); // the first one in iw is the strongest
@@ -120,4 +124,4 @@
 		ptcls( i ) = ptcls( i ); //potentionally dangerous!
 	}
-	*/
+	
 }
Index: /bdm/math/libDC.h
===================================================================
--- /bdm/math/libDC.h (revision 26)
+++ /bdm/math/libDC.h (revision 28)
@@ -81,4 +81,6 @@
 		int rows() const {return dim;};
 
+		//! Destructor for future use;
+		virtual ~sqmat(){};
 	protected:
 		int dim;
@@ -110,4 +112,8 @@
 		fsqmat ( const mat &M );
 
+		//! Destructor for future use;
+		virtual ~fsqmat(){};
+
+
 		/*! \brief Matrix inversion preserving the chosen form.
 
@@ -144,4 +150,7 @@
 		//! Default initialization with proper size
 		ldmat(const int dim0);
+
+		//! Destructor for future use;
+		virtual ~ldmat(){};
 
 		// Reimplementation of compulsory operatios
Index: /bdm/stat/libEF.h
===================================================================
--- /bdm/stat/libEF.h (revision 27)
+++ /bdm/stat/libEF.h (revision 28)
@@ -26,9 +26,14 @@
 * More?...
 */
+
 class eEF : public epdf {
 
 public:
-	virtual void tupdate( double phi, mat &vbar, double nubar ) {};
-	virtual void dupdate( mat &v,double nu=1.0 ) {};
+	//! default constructor
+	eEF() :epdf() {};
+
+	virtual void tupdate ( double phi, mat &vbar, double nubar ) {};
+
+	virtual void dupdate ( mat &v,double nu=1.0 ) {};
 };
 
@@ -45,23 +50,45 @@
 */
 template<class sq_T>
+
 class enorm : public eEF {
+protected:
+	//! mean value
+	vec mu;
+	//! Covariance matrix in decomposed form
+	sq_T R;
+	//! Cache:  _iR = inv(R);
+	sq_T _iR;
+	//! indicator if \c _iR is chached
+	bool cached;
+	//! Random number generator for sampling; Fixme: what about *static* correct ?
+	Normal_RNG RNG;
+	//! dimension (redundant from rv.count() for easier coding )
 	int dim;
-	vec mu;
-	sq_T R;
-public:
-	enorm( RV &rv, vec &mu, sq_T &R );
-	enorm();
+public:
+	enorm() :eEF() {};
+
+	enorm ( RV &rv );
+	void set_parameters ( const vec &mu,const sq_T &R );
 	//! tupdate in exponential form (not really handy)
-	void tupdate( double phi, mat &vbar, double nubar );
-	void dupdate( mat &v,double nu=1.0 );
-	//!tupdate used in KF
-	void tupdate();
-	//!dupdate used in KF
-	double dupdate();
-	 
+	void tupdate ( double phi, mat &vbar, double nubar );
+	void dupdate ( mat &v,double nu=1.0 );
+
 	vec sample();
-	mat sample(int N);
-	double eval( const vec &val );
-	Normal_RNG RNG;
+	mat sample ( int N );
+	double eval ( const vec &val );
+	double evalpdflog ( const vec &val );
+
+//Access methods
+	//! returns a pointer to the internal mean value. Use with Care!
+	vec* _mu() {return &mu;}
+
+	//! returns pointers to the internal variance and its inverse. Use with Care!
+	void _R ( sq_T* &pR, sq_T* &piR ) {
+		pR=&R;
+		piR=&_iR;
+	}
+
+	//! set cache as inconsistent
+	void _cached ( bool what ) {cached=what;}
 };
 
@@ -70,4 +97,5 @@
 */
 template<class sq_T>
+
 class mlnorm : public mEF {
 	enorm<sq_T> epdf;
@@ -75,9 +103,9 @@
 public:
 	//! Constructor
-	mlnorm( RV &rv,RV &rvc, mat &A, sq_T &R );
+	mlnorm ( RV &rv,RV &rvc, mat &A, sq_T &R );
 	//!Generate one sample of the posterior
-	vec samplecond( vec &cond, double &lik );
-	mat samplecond( vec &cond, vec &lik, int n );
-	void condition( vec &cond );
+	vec samplecond ( vec &cond, double &lik );
+	mat samplecond ( vec &cond, vec &lik, int n );
+	void condition ( vec &cond );
 };
 
@@ -85,17 +113,23 @@
 
 template<class sq_T>
-enorm<sq_T>::enorm( RV &rv, vec &mu0, sq_T &R0 ) {
-	dim = rv.count();
+enorm<sq_T>::enorm ( RV &rv ) :eEF(), mu ( rv.count() ),R(rv.count()),_iR(rv.count()),cached ( false ),dim ( rv.count() ) {};
+
+template<class sq_T>
+void enorm<sq_T>::set_parameters ( const vec &mu0, const sq_T &R0 ) {
+//Fixme test dimensions of mu0 and R0;
 	mu = mu0;
 	R = R0;
-};
-
-template<class sq_T>
-void enorm<sq_T>::dupdate( mat &v, double nu ) {
+	if(_iR.rows()!=R.rows()) _iR=R; // memory allocation!
+	R.inv ( _iR ); //update cache
+	cached=true;
+};
+
+template<class sq_T>
+void enorm<sq_T>::dupdate ( mat &v, double nu ) {
 	//
 };
 
 template<class sq_T>
-void enorm<sq_T>::tupdate( double phi, mat &vbar, double nubar ) {
+void enorm<sq_T>::tupdate ( double phi, mat &vbar, double nubar ) {
 	//
 };
@@ -103,7 +137,7 @@
 template<class sq_T>
 vec enorm<sq_T>::sample() {
-	vec x( dim );
-	RNG.sample_vector( dim,x );
-	vec smp = R.sqrt_mult( x );
+	vec x ( dim );
+	RNG.sample_vector ( dim,x );
+	vec smp = R.sqrt_mult ( x );
 
 	smp += mu;
@@ -112,63 +146,79 @@
 
 template<class sq_T>
-mat enorm<sq_T>::sample( int N ) {
-	mat X( dim,N );
-	vec x( dim );
+mat enorm<sq_T>::sample ( int N ) {
+	mat X ( dim,N );
+	vec x ( dim );
 	vec pom;
 	int i;
+
 	for ( i=0;i<N;i++ ) {
-		RNG.sample_vector( dim,x );
-		pom = R.sqrt_mult( x );
+		RNG.sample_vector ( dim,x );
+		pom = R.sqrt_mult ( x );
 		pom +=mu;
-		X.set_col( i, pom);
+		X.set_col ( i, pom );
 	}
+
 	return X;
 };
 
 template<class sq_T>
-double enorm<sq_T>::eval( const vec &val ) {
-	return 0.0;	
-};
-
-
-template<class sq_T>
-enorm<sq_T>::enorm() {};
-
-template<class sq_T>
-mlnorm<sq_T>::mlnorm( RV &rv,RV &rvc, mat &A, sq_T &R ) {
+double enorm<sq_T>::eval ( const vec &val ) {
+	return exp ( evalpdflog ( val ) );
+};
+
+template<class sq_T>
+double enorm<sq_T>::evalpdflog ( const vec &val ) {
+	if ( !cached ) {R.inv ( _iR );cached=true;}
+
+	return -0.5* ( R.cols() *0.79817986835811504957 +R.logdet() +_iR.qform ( mu-val ) );
+};
+
+
+template<class sq_T>
+mlnorm<sq_T>::mlnorm ( RV &rv,RV &rvc, mat &A, sq_T &R ) {
 	int dim = rv.count();
-	vec mu( dim );
-
-	epdf = enorm<sq_T>( rv,mu,R );
-}
-
-template<class sq_T>
-vec mlnorm<sq_T>::samplecond( vec &cond, double &lik ) {
-	this->condition( cond );
+	vec mu ( dim );
+
+	epdf = enorm<sq_T> ( rv,mu,R );
+}
+
+template<class sq_T>
+vec mlnorm<sq_T>::samplecond ( vec &cond, double &lik ) {
+	this->condition ( cond );
 	vec smp = epdf.sample();
-	lik = epdf.eval( smp );
+	lik = epdf.eval ( smp );
 	return smp;
 }
 
 template<class sq_T>
-mat mlnorm<sq_T>::samplecond( vec &cond, vec &lik, int n ) {
+mat mlnorm<sq_T>::samplecond ( vec &cond, vec &lik, int n ) {
 	int i;
 	int dim = rv.count();
-	mat Smp( dim,n );
-	vec smp( dim );
-	this->condition( cond );
+	mat Smp ( dim,n );
+	vec smp ( dim );
+	this->condition ( cond );
+
 	for ( i=0; i<dim; i++ ) {
 		smp = epdf.sample();
-		lik( i ) = epdf.eval( smp );
-		Smp.set_col( i ,smp );
+		lik ( i ) = epdf.eval ( smp );
+		Smp.set_col ( i ,smp );
 	}
+
 	return Smp;
 }
 
 template<class sq_T>
-void mlnorm<sq_T>::condition( vec &cond ) {
+void mlnorm<sq_T>::condition ( vec &cond ) {
 	epdf.mu = A*cond;
 //R is already assigned;
 }
 
+///////////
+
+//#ifdef HAVE_EXTERN_TEMPLATE
+
+//  extern template class enorm<fsqmat>;
+//  extern template class enorm<ldmat>;
+//#endif
+
 #endif //EF_H
Index: /bdm/stat/libBM.h
===================================================================
--- /bdm/stat/libBM.h (revision 27)
+++ /bdm/stat/libBM.h (revision 28)
@@ -84,23 +84,9 @@
 	//! access function
 	int _dimy()const{return dimy;}
+
+		//! Destructor for future use;
+		virtual ~fnc(){};
 };
 
-//! Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities.
-class BM {
-public:
-	//!Logarithm of marginalized data likelihood.
-	double ll;
-
-	//!Default constructor
-	BM(){ll=0;};
-	
-	/*! \brief Incremental Bayes rule
-	@param dt vector of input data
-	@param evall If true, the filter will compute likelihood of the data record and store it in \c ll
-	*/
-	virtual void bayes ( const vec &dt, bool evall=true ) = 0;
-	//! Batch Bayes rule (columns of Dt are observations)
-	void bayes ( mat Dt );
-};
 
 //! Probability density function with numerical statistics, e.g. posterior density.
@@ -108,4 +94,6 @@
 	RV rv;
 public:
+	//!default constructor
+	epdf():rv(ivec(0)){};
 	//! Returns the required moment of the epdf
 //	virtual vec moment ( const int order = 1 );
@@ -113,8 +101,10 @@
 	virtual vec sample ()=0;
 	//! Compute probability of argument \c val
-	virtual double eval(const vec &val)
-	{
-		return 0.0;
-	};
+	virtual double eval(const vec &val){return 0.0;};
+	//! Compute log-probability of argument \c val
+	virtual double evalpdflog(const vec &val){return 0.0;};
+
+		//! Destructor for future use;
+		virtual ~epdf(){};
 };
 
@@ -130,6 +120,9 @@
 //	virtual fnc moment ( const int order = 1 );
 	//! Returns a sample from the density conditioned on \c cond, $x \sim epdf(rv|cond)$
-	virtual vec samplecond (vec &cond, double lik){};
+	virtual vec samplecond (vec &cond, double lik){return vec(0);};
 	virtual void condition (vec &cond){};
+
+		//! Destructor for future use;
+		virtual ~mpdf(){};
 };
 
@@ -164,6 +157,32 @@
 	//! Moves from $t$ to $t+1$, i.e. perfroms the actions and reads response of the system. 
 	void step();
+		
 };
 
+/*! \brief Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities.
+	
+*/
+class BM {
+public:
+	//!Logarithm of marginalized data likelihood.
+	double ll;
+	//!  If true, the filter will compute likelihood of the data record and store it in \c ll . Set to false if you want to save time.
+	bool evalll;
+
+	//!Default constructor
+	BM():ll(0),evalll(true){};
+	
+	/*! \brief Incremental Bayes rule
+	@param dt vector of input data
+	*/
+	virtual void bayes ( const vec &dt) = 0;
+	//! Batch Bayes rule (columns of Dt are observations)
+	void bayes ( mat Dt );
+	//! Returns a pointer to the epdf representing posterior density on parameters. Use with care!
+	virtual epdf* _epdf()=0;
+
+		//! Destructor for future use;
+		virtual ~BM(){};
+};
 
 #endif // BM_H
Index: /tests/test0.cpp
===================================================================
--- /tests/test0.cpp (revision 24)
+++ /tests/test0.cpp (revision 28)
@@ -14,5 +14,4 @@
 	RV th = RV ( "1 2","{a b }","1 1","0 0","0 0" );
 	RV r = RV ( "3 4" );
-	int i =0;
 
 	cout << th << r << endl;
@@ -42,5 +41,5 @@
 
 	cout << "Test ldform()"<<endl;
-	mat V = "1 2; 2 3"; 
+	mat V = "1 2; 2 13"; 
 	ldmat lV(V);
 	ldmat ilV(V);  
Index: /tests/testSmp.cpp
===================================================================
--- /tests/testSmp.cpp (revision 22)
+++ /tests/testSmp.cpp (revision 28)
@@ -17,5 +17,6 @@
 	mat V0("1.2 0.3; 0.3 5");
 	ldmat R = ldmat(V0);
-	enorm<ldmat> eN(rv,mu0,R);
+	enorm<ldmat> eN(rv);
+	eN.set_parameters(mu0,R);
 	
 	mat Smp = eN.sample(N);
Index: /tests/testKF.cpp
===================================================================
--- /tests/testKF.cpp (revision 22)
+++ /tests/testKF.cpp (revision 28)
@@ -22,4 +22,5 @@
 
 	bool xxx= fin.seek( "d" );
+	if (!xxx){ it_error("testKF.it not found");}
 	fin >>Dt;
 	fin.seek( "A" ); 
@@ -43,26 +44,36 @@
 	XtE=zeros( 2,Ndat );
 
-	Kalman<fsqmat> KF( A,B,C,D,fsqmat(R),fsqmat(Q),fsqmat(P0),mu0 );
 //	cout << KF;
-	KalmanFull KF2( A,B,C,D,R,Q,P0,mu0 );
 	RV rx("1","{x}","2","0","0");
 	RV ru("2","{u}","1","0","0");
 	RV ry("3","{y}","1","0","0");
+	//
+	Kalman<ldmat> KF(rx,ry,ru);
+	KF.set_parameters(A,B,C,D,ldmat(R),ldmat(Q));
+	KF.set_est(mu0,ldmat(P0) );
+	//
+	Kalman<fsqmat> KFf(rx,ry,ru);
+	KFf.set_parameters(A,B,C,D,fsqmat(R),fsqmat(Q));
+	KFf.set_est(mu0,fsqmat(P0) );
+	//
+	KalmanFull KF2( A,B,C,D,R,Q,P0,mu0 );
+	//
 	bilinfn fxu(rx,ru,A,B);
 	bilinfn hxu(rx,ru,C,D);
-	EKF<fsqmat> KFE(&fxu,&hxu,Q,R,mu0,P0);
+	EKF<ldmat> KFE(rx,ry,ru);
+	KFE.set_parameters(&fxu,&hxu,Q,R);
+	KFE.set_est(mu0,P0);
 
-	Xt.set_col( 0,KF.mu );
-	Xt2.set_col( 0,KF.mu );
-	XtE.set_col( 0,KF.mu );
+	Xt.set_col( 0,*((enorm<ldmat>*)(KF._epdf()))->_mu() );
+	Xt2.set_col( 0,KF2.mu );
+	XtE.set_col( 0,*((enorm<ldmat>*)(KFE._epdf()))->_mu() );
 	for ( int t=1;t<Ndat;t++ ) {
+		KFf.bayes( Dt.get_col( t ));
 		KF.bayes( Dt.get_col( t ));
 		KF2.bayes( Dt.get_col( t ));
-		KFE.bayes( Dt.get_col( t ));
-		Xt.set_col(t,KF.mu);
+//		KFE.bayes( Dt.get_col( t ));
+		Xt.set_col(t,*((enorm<ldmat>*)(KF._epdf()))->_mu());
 		Xt2.set_col(t,KF2.mu);
-		XtE.set_col(t,KFE.mu);
-//		Kmu = KF.mu;
-//		cout <<  "t:" <<t<< "  " << dt<<"  "<<Kmu <<endl;
+		XtE.set_col(t,*((enorm<ldmat>*)(KFE._epdf()))->_mu());
 	}
 
Index: /Doxyfile
===================================================================
--- /Doxyfile (revision 19)
+++ /Doxyfile (revision 28)
@@ -24,5 +24,5 @@
                          the
 ALWAYS_DETAILED_SEC    = NO
-INLINE_INHERITED_MEMB  = NO
+INLINE_INHERITED_MEMB  = YES
 FULL_PATH_NAMES        = YES
 STRIP_FROM_PATH        = /home/smidl/
Index: /BDM.kdevelop.filelist
===================================================================
--- /BDM.kdevelop.filelist (revision 22)
+++ /BDM.kdevelop.filelist (revision 28)
@@ -1,3 +1,2 @@
-# KDevelop Custom Project File List
 CMakeLists.txt
 bdm/CMakeLists.txt
Index: /doc/html/classTrivialPF__coll__graph.md5
===================================================================
--- /doc/html/classTrivialPF__coll__graph.md5 (revision 23)
+++ /doc/html/classTrivialPF__coll__graph.md5 (revision 28)
@@ -1,1 +1,1 @@
-6c68223e40f77452ac769094ee74c41c
+13a92e808324a6ca95a65924a5935ad1
Index: /doc/html/classEKF__coll__graph.md5
===================================================================
--- /doc/html/classEKF__coll__graph.md5 (revision 23)
+++ /doc/html/classEKF__coll__graph.md5 (revision 28)
@@ -1,1 +1,1 @@
-80e8a90e18a613ab2239b0c07bbf7889
+f0af3ae76b214ecac356cc7e830905d0
Index: /BDM.kdevelop
===================================================================
--- /BDM.kdevelop (revision 22)
+++ /BDM.kdevelop (revision 28)
@@ -2,9 +2,9 @@
 <kdevelop>
   <general>
-    <projectmanagement>KDevCustomProject</projectmanagement>
-    <projectdirectory>/home/smidl/work/mixpp</projectdirectory>
-    <absoluteprojectpath>true</absoluteprojectpath>
-    <author></author>
-    <email></email>
+  <projectmanagement>KDevCustomProject</projectmanagement>
+  <projectdirectory>/home/smidl/work/mixpp</projectdirectory>
+  <absoluteprojectpath>true</absoluteprojectpath>
+    <author/>
+    <email/>
     <version>$VERSION$</version>
     <primarylanguage>C++</primarylanguage>
@@ -14,6 +14,6 @@
     </secondaryLanguages>
     <projectname>BDM</projectname>
-    <description></description>
-    <defaultencoding></defaultencoding>
+    <description/>
+    <defaultencoding/>
     <versioncontrol>kdevsubversion</versioncontrol>
   </general>
@@ -24,9 +24,9 @@
       <directoryradio>custom</directoryradio>
       <customdirectory>/home/smidl/work/mixpp</customdirectory>
-      <programargs></programargs>
+      <programargs/>
       <terminal>false</terminal>
       <autocompile>true</autocompile>
       <envvars/>
-      <globaldebugarguments></globaldebugarguments>
+      <globaldebugarguments/>
       <globalcwd>/home/smidl/work/mixpp</globalcwd>
       <useglobalprogram>false</useglobalprogram>
@@ -42,5 +42,5 @@
       <numberofjobs>0</numberofjobs>
       <dontact>false</dontact>
-      <makebin></makebin>
+      <makebin/>
       <selectedenvironment>default</selectedenvironment>
       <environments>
@@ -48,6 +48,6 @@
       </environments>
       <prio>0</prio>
-      <defaulttarget></defaulttarget>
-      <makeoptions></makeoptions>
+      <defaulttarget/>
+      <makeoptions/>
     </make>
     <filetypes>
@@ -70,7 +70,7 @@
     <other>
       <prio>0</prio>
-      <otherbin></otherbin>
-      <defaulttarget></defaulttarget>
-      <otheroptions></otheroptions>
+      <otherbin/>
+      <defaulttarget/>
+      <otheroptions/>
       <selectedenvironment>default</selectedenvironment>
       <environments>
@@ -144,5 +144,5 @@
     </qt>
     <creategettersetter>
-      <prefixGet></prefixGet>
+      <prefixGet/>
       <prefixSet>set</prefixSet>
       <prefixVariable>m_,_</prefixVariable>
@@ -152,5 +152,5 @@
     </creategettersetter>
     <splitheadersource>
-      <enabled>true</enabled>
+      <enabled>false</enabled>
       <synchronize>true</synchronize>
       <orientation>Vertical</orientation>
@@ -174,12 +174,12 @@
   <kdevdebugger>
     <general>
-      <projectmanagement>KDevCustomProject</projectmanagement>
-      <projectdirectory>/home/smidl/work/mixpp</projectdirectory>
-      <absoluteprojectpath>true</absoluteprojectpath>
-      <gdbpath></gdbpath>
-      <dbgshell></dbgshell>
-      <configGdbScript></configGdbScript>
-      <runShellScript></runShellScript>
-      <runGdbScript></runGdbScript>
+  <projectmanagement>KDevCustomProject</projectmanagement>
+  <projectdirectory>/home/smidl/work/mixpp</projectdirectory>
+  <absoluteprojectpath>true</absoluteprojectpath>
+      <gdbpath/>
+      <dbgshell/>
+      <configGdbScript/>
+      <runShellScript/>
+      <runGdbScript/>
       <breakonloadinglibs>true</breakonloadinglibs>
       <separatetty>false</separatetty>
Index: /CMakeLists.txt
===================================================================
--- /CMakeLists.txt (revision 25)
+++ /CMakeLists.txt (revision 28)
@@ -30,4 +30,5 @@
 	#This is for UNIX makefile which does only one release at a time.
 	SET(CMAKE_BUILD_TYPE Debug)
+	SET(CMAKE_CXX_FLAGS_DEBUG "-g -Wall")
 ENDIF(WIN32)
 
